import { IDate, IDateLocal, IDayMonthYear, IDaysOfMonth, IUnityOfTime, IWeeksOfMonth } from './core-services-date.interface';
declare class Get {
    customDate(date: IDate, format: string): string;
    currentDate(outputFormat?: string): string;
    dayMonthYear(date: IDate, format?: string): IDayMonthYear;
    localDate(year: number, month: number, day: number, local?: IDateLocal): string;
    dateFromIso(date: IDate, format?: string): string;
    ganttDate(date: IDate): Date;
    isoDateCustom(date: IDate, dateFormat: string, outputFormat: string): string;
    isoDate(date: IDate, format?: string): string;
    isoDateWithoutTime(date: IDate): string;
    dateMilliseconds(date: IDate, dateFormat: string, outputFormat: string): number;
    dateToMillisecondsNoTime(date: IDate): number;
    millisecondsToDate(date: IDate, outputFormat: string): string;
    daysToMilliseconds(days: number): number;
    durationInDays(start: number, end: number, countFirstDay: boolean): number;
    durationInMilliseconds(start: number, end: number): number;
    monthName(month: number, language?: string): string;
    weeksOfMonth(year: number, month: number): IWeeksOfMonth[];
    daysOfMonth(weeksRange: IWeeksOfMonth[]): IDaysOfMonth[][];
    weekOfYear(date: string, format: string): number;
}
export declare const DateGet: Get;
declare class Comparable {
    isDateBefore(startDate: string, endDate: string, type?: IUnityOfTime): boolean;
}
export declare const DateComparable: Comparable;
declare class Validation {
    date(date: IDate): boolean;
}
export declare const DateValidation: Validation;
declare class Picker {
    setDatePicker(datePicker: HTMLInputElement, dateFormat: string): void;
    monthYearDatePicker(datePicker: HTMLInputElement, dateFormat: string, setValueCallback: any): void;
    dateFromDatePicker(date: IDate, format?: string, outputFormat?: string): string;
    localDateForDatePicker(date: IDate, outputFormat?: string): string;
    currentDateForDatePicker(dateFormat?: string, outputFormat?: string): string;
    dateForDatePicker(month: number, day: number, year: number): string;
}
export declare const DatePicker: Picker;
export {};
