/// <reference types="node" />
import { Cell, Column, CoreProperties, Range, Row, Sheet } from 'xlsx-populate';
export declare type IExcelFileName = string | null;
export interface IExcelResult {
    code: number;
    message: string;
}
export declare type IExcelCell = string | boolean | number | null | undefined;
export interface IExcelWorkbook {
    activeSheet(): Sheet;
    activeSheet(sheet: Sheet | string | number): IExcelWorkbook;
    addSheet(name: string, indexOrBeforeSheet?: number | string | Sheet): Sheet;
    definedName(name: string): undefined | string | Cell | Range | Row | Column;
    definedName(name: string, refersTo: string | Cell | Range | Row | Column): IExcelWorkbook;
    deleteSheet(sheet: Sheet | string | number): IExcelWorkbook;
    find(pattern: string | RegExp, replacement?: string | Function): boolean;
    moveSheet(sheet: Sheet | string | number, indexOrBeforeSheet?: number | string | Sheet): IExcelWorkbook;
    outputAsync(type?: string | Uint8Array | ArrayBuffer | Blob | Buffer): Promise<string | Uint8Array | ArrayBuffer | Blob | Buffer>;
    outputAsync(opts?: object): string | Uint8Array | ArrayBuffer | Blob | Buffer;
    sheet(sheetNameOrIndex: number | string): Sheet;
    sheets(): Sheet[];
    property(name: string): any;
    property(names: string[]): {
        [key: string]: any;
    };
    property(properties: {
        [key: string]: any;
    }): IExcelWorkbook;
    property(name: string, value: any): IExcelWorkbook;
    properties(): CoreProperties;
    toFileAsync(path: string, opts?: object): Promise<void>;
    cloneSheet(from: Sheet, name: string, indexOrBeforeSheet?: number | string | Sheet): Sheet;
}
